if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$PlayerAbils::PrefsSet)
	{
		if(!$RTB::RTBR_ServerControl_Hook)
		{
			exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
		}
		// Description, ModName, Variable, Properties, Mod, Default value, Requires Restart, Super-Admin Only, Callback Function
		RTB_registerPref("Suicide Enabled", "Player Abilities", "Pref::PlayerAbil::SuicideEnabled", "bool", "Server_PlayerAbils", 1, 0, 1, "Suicide_UpdateMethod");
		RTB_registerPref("Light Enabled", "Player Abilities", "Pref::PlayerAbil::LightEnabled", "bool", "Server_PlayerAbils", 1, 0, 1, "Light_UpdateMethod");
		RTB_registerPref("Emotes Enabled", "Player Abilities", "Pref::PlayerAbil::EmotesEnabled", "bool", "Server_PlayerAbils", 1, 0, 1, "Emotes_UpdateMethod");
		RTB_registerPref("Wand Enabled", "Player Abilities", "Pref::PlayerAbil::WandEnabled", "bool", "server_PlayerAbils", 1, 0, 1, "Wand_UpdateMethod");
		RTB_registerPref("Emote Exception 1", "Player Abilities", "Pref::PlayerAbil::EmoteExceptA", "list NONE 0 Alarm 1 Confusion/Wtf 2 Hate 3 Hug/Zombie 4 Love 5 Sit 6", "Server_PlayerAbils", 0, 0, 1, "ExceptA_UpdateMethod");
		RTB_registerPref("Emote Exception 2", "Player Abilities", "Pref::PlayerAbil::EmoteExceptB", "list NONE 0 Alarm 1 Confusion/Wtf 2 Hate 3 Hug/Zombie 4 Love 5 Sit 6", "Server_PlayerAbils", 0, 0, 1, "ExceptB_UpdateMethod");
		RTB_registerPref("Set To Defaults", "Player Abilities", "Pref::PlayerAbil::Default", "bool", "Server_PlayerAbils", 0, 0, 1, "PlayerAbil_Default");
		$PlayerAbils::PrefsSet = 1;
	}
}
else
{
	// If you do not have RTB you can change the preferences here
	$Pref::PlayerAbil::SuicideEnabled = 1;			// Enable suicide?
	$Pref::PlayerAbil::LightEnabled = 1;			// Enable lights?
	$Pref::PlayerAbil::EmotesEnabled = 1;			// Enable emotes?
	$Pref::PlayerAbil::WandEnabled = 1;			// Enable the wand?
	$Pref::PlayerAbil::EmoteExceptA = 0;			// Allow an exception for a specific emote?
	$Pref::PlayerAbil::EmoteExceptB = 0;			// Allow an exception for a specific emote?
	$Pref::PlayerAbil::Default = 0;				// Not actually required if you don't have RTB.
}

//The actual code.
function servercmdsuicide(%client){if($Pref::PlayerAbil::SuicideEnabled && %client.Player != '0'){%client.Player.Kill();}else{%client.centerPrint("<color:ffffff>Suicide is currently disabled.", 2);}}

package overwriteEmotes{function servercmdalarm(%client){if($Pref::PlayerAbil::EmotesEnabled || ($Pref::PlayerAbil::EmoteExceptA == 1 || $Pref::PlayerAbil::EmoteExceptB == 1)){Parent::servercmdAlarm(%client);}else{EmotesMsg(%client);}}function servercmdConfusion(%client){if($Pref::PlayerAbil::EmotesEnabled || ($Pref::PlayerAbil::EmoteExceptA == 2 || $Pref::PlayerAbil::EmoteExceptB == 2)){Parent::servercmdConfusion(%client);}else{EmotesMsg(%client);}}function servercmdhate(%client){if($Pref::PlayerAbil::EmotesEnabled || ($Pref::PlayerAbil::EmoteExceptA == 3 || $Pref::PlayerAbil::EmoteExceptB == 3)){Parent::servercmdHate(%client);}else{EmotesMsg(%client);}}function servercmdhug(%client){if($Pref::PlayerAbil::EmotesEnabled || ($Pref::PlayerAbil::EmoteExceptA == 4 || $Pref::PlayerAbil::EmoteExceptB == 4)){Parent::servercmdHug(%client);}else{EmotesMsg(%client);}}function servercmdlove(%client){if($Pref::PlayerAbil::EmotesEnabled || ($Pref::PlayerAbil::EmoteExceptA == 5 || $Pref::PlayerAbil::EmoteExceptB == 5)){Parent::servercmdLove(%client);}else{EmotesMsg(%client);}}function servercmdsit(%client){if($Pref::PlayerAbil::EmotesEnabled || ($Pref::PlayerAbil::EmoteExceptA == 6 || $Pref::PlayerAbil::EmoteExceptB == 6)){Parent::servercmdSit(%client);}else{EmotesMsg(%client);}}function servercmdwtf(%client){if($Pref::PlayerAbil::EmotesEnabled || ($Pref::PlayerAbil::EmoteExceptA == 2 || $Pref::PlayerAbil::EmoteExceptB == 2)){Parent::servercmdWtf(%client);}else{EmotesMsg(%client);}}function servercmdzombie(%client){if($Pref::PlayerAbil::EmotesEnabled || ($Pref::PlayerAbil::EmoteExceptA == 4 || $Pref::PlayerAbil::EmoteExceptB == 4)){Parent::servercmdZombie(%client);}else{EmotesMsg(%client);}}};
package overwriteLight{function servercmdlight(%client){if($Pref::PlayerAbil::LightEnabled && %client.Player != '0'){Parent::servercmdLight(%client);}else{%client.centerPrint("<color:ffffff>Lights are currently disabled.", 2);}}};
package overwriteRBC{function servercmdrealbrickcount(%client){Parent::servercmdBrickcount(%client);}};
package overwriteWand{function servercmdwand(%client){if($Pref::PlayerAbil::WandEnabled){Parent::servercmdWand(%client);}else{%client.centerPrint("<color:ffffff>The wand is currently disabled.", 2);}}};

function Suicide_UpdateMethod(%oldVal){schedule(0, 0, "messageAll", '', "\c3+ Player Abilities\c0 - Suicide is now " @ (%oldVal ? "\c3disabled" : "\c3enabled") @ "\c0.");}
function Light_UpdateMethod(%oldVal){schedule(0, 0, "messageAll", '', "\c3+ Player Abilities\c0 - Lights are now " @ (%oldVal ? "\c3disabled" : "\c3enabled") @ "\c0.");}
function Emotes_UpdateMethod(%oldVal){schedule(0, 0, "messageAll", '', "\c3+ Player Abilities\c0 - All emotes are now " @ (%oldVal ? "\c3disabled" : "\c3enabled") @ "\c0.");if(%oldVal == 1){schedule(0, 0, "messageAll", '', "\c3+ Player Abilities\c0 - The emote exceptions are \c3" @ EmotesMsgSubC($Pref::PlayerAbil::EmoteExceptA) @ "\c0 and \c3" @ EmotesMsgSubC($Pref::PlayerAbil::EmoteExceptB) @ "\c0.");}}
function Wand_UpdateMethod(%oldVal){schedule(0, 0, "messageAll", '', "\c3+ Player Abilities\c0 - The Wand tool is now " @ (%oldVal ? "\c3disabled" : "\c3enabled") @ "\c0.");}
function ExceptA_UpdateMethod(%oldVal){if($Pref::PlayerAbil::EmotesEnabled == 0){schedule(0, 0, "messageAll", '', "\c3+ Player Abilities\c0 - The first emote exception is now \c3" @ EmotesMsgSubC($Pref::PlayerAbil::EmoteExceptA) @ "\c0.");}}
function ExceptB_UpdateMethod(%oldVal){if($Pref::PlayerAbil::EmotesEnabled == 0){schedule(0, 0, "messageAll", '', "\c3+ Player Abilities\c0 - The second emote exception is now \c3" @ EmotesMsgSubC($Pref::PlayerAbil::EmoteExceptB) @ "\c0.");}}


function PlayerAbil_Default(){schedule(0, 0, "messageAll", '', "\c3+ Player Abilities\c0 - All preferences for Server_PlayerAbil have been set to their defaults.");$Pref::PlayerAbil::SuicideEnabled = 1;$Pref::PlayerAbil::LightEnabled = 1;$Pref::PlayerAbil::EmotesEnabled = 1;$Pref::PlayerAbil::WandEnabled = 1;$Pref::PlayerAbil::EmoteExceptA = 0;$Pref::PlayerAbil::EmoteExceptB = 0;$Pref::PlayerAbil::Default = 0;}


function EmotesMsg(%client){if($Pref::PlayerAbil::EmoteExceptA == 0){if($Pref::PlayerAbil::EmoteExceptB == 0){%client.centerPrint("<color:ffffff>All emotes are currently disabled.", 2);}else{EmotesMsgSubA(%client, $Pref::PlayerAbil::EmoteExceptB);}}else{if($Pref::PlayerAbil::EmoteExceptB == 0){EmotesMsgSubA(%client, $Pref::PlayerAbil::EmoteExceptA);}else{if($Pref::PlayerAbil::EmoteExceptA == $Pref::PlayerAbil::EmoteExceptB){EmotesMsgSubA(%client, $Pref::PlayerAbil::EmoteExceptA);}else{EmotesMsgSubB(%client, $Pref::PlayerAbil::EmoteExceptA, $Pref::PlayerAbil::EmoteExceptB);}}}}
function EmotesMsgSubA(%client, %case){%type = "";switch$(%case){case 1:%type = "Alarm";case 2:%type = "Confusion/Wtf";case 3:%type = "Hate";case 4:%type = "Hug/Zombie";case 5:%type = "Love";case 6:%type = "Sit";default:%type = "<color:ff0000>ERROR";}%client.centerPrint("<color:ffffff>All emotes except for <color:ffff00>" @ %type @ "<color:ffffff> are currently disabled.", 2);}
function EmotesMsgSubB(%client, %casea, %caseb){%typea = "";%typeb = "";switch$(%casea){case 1:%typea = "Alarm";case 2:%typea = "Confusion/Wtf";case 3:%typea = "Hate";case 4:%typea = "Hug/Zombie";case 5:%typea = "Love";case 6:%typea = "Sit";default:%type = "<color:ff0000>ERROR";}switch$(%caseb){case 1:%typeb = "Alarm";case 2:%typeb = "Confusion/Wtf";case 3:%typeb = "Hate";case 4:%typeb = "Hug/Zombie";case 5:%typeb = "Love";case 6:%typeb = "Sit";default:%type = "<color:ff0000>ERROR";}%client.centerPrint("<color:ffffff>All emotes except for <color:ffff00>" @ %typea @ "<color:ffffff> and <color:ffff00>" @ %typeb @ "<color:ffffff> are currently disabled.", 2);}
function EmotesMsgSubC(%case){%type = "";switch$(%case){case 0:%type = "blank";case 1:%type = "Alarm";case 2:%type = "Confusion/Wtf";case 3:%type = "Hate";case 4:%type = "Hug/Zombie";case 5:%type = "Love";case 6:%type = "Sit";default:%type = "<color:ff0000>ERROR";}return %type;}



activatePackage(overwriteEmotes);
activatePackage(overwriteLight);
activatePackage(overwriteRBC);
activatePackage(overwriteWand);